net.sf.saxon.pattern

## Class AncestorQualifiedPattern

- java.lang.Object
- - net.sf.saxon.pattern.Pattern
  - - net.sf.saxon.pattern.AncestorQualifiedPattern

- All Implemented Interfaces:
    Serializable, SourceLocator, Container, PatternFinder

      public final class AncestorQualifiedPattern
      extends Pattern

  An AncestorQualifiedPattern represents a path of the form A/B or A//B, where nodes must match the pattern B and also have a parent/ancestor (respectively) that matches A.
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AncestorQualifiedPattern(Pattern base, Pattern upper, byte axis)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `allocateSlots(SlotManager slotManager, int nextFree)` Allocate slots to any variables used within the pattern
    `Pattern` | `analyze(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Type-check the pattern, performing any type-dependent optimizations.
    `void` | `bindCurrent(Binding binding)` Replace any calls on current() by a variable reference bound to the supplied binding
    `boolean` | `equals(Object other)` Determine whether this pattern is the same as another pattern
    `Pattern` | `getBasePattern()` Get the base pattern, the pattern applying to the node itself
    `int` | `getDependencies()` Get the dependencies of the pattern.
    `int` | `getFingerprint()` Determine the fingerprint of nodes to which this pattern applies.
    `ItemType` | `getItemType()` Get a NodeTest that all the nodes matching this pattern must satisfy
    `int` | `getNodeKind()` Determine the types of nodes to which this pattern applies.
    `Pattern` | `getUpperPattern()` Get the pattern applying to the parent node, if there is one
    `byte` | `getUpwardsAxis()` Get the upwards axis, that is, the axis by which the upper pattern is reached.
    `int` | `hashCode()` hashcode supporting equals()
    `boolean` | `isMotionless(boolean allowExtensions)` Test whether a pattern is motionless, that is, whether it can be evaluated against a node without repositioning the input stream.
    `Iterator<Expression>` | `iterateSubExpressions()` Iterate over the subexpressions within this pattern
    `boolean` | `matches(Item item, XPathContext context)` Determine whether the pattern matches a given item.
    `boolean` | `matchesBeneathAnchor(NodeInfo node, NodeInfo anchor, XPathContext context)` Determine whether this pattern matches a given Node within the subtree rooted at a given anchor node.
    `void` | `promote(PromotionOffer offer, Expression parent)` Offer promotion for subexpressions within this pattern.
    `boolean` | `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
    `void` | `setExecutable(Executable executable)` Set the executable containing this pattern
    `void` | `setLineNumber(int lineNumber)` Set the line number where the pattern occurred
    `void` | `setSystemId(String systemId)` Set the system ID where the pattern occurred
    `Pattern` | `simplify(ExpressionVisitor visitor)` Simplify the pattern: perform any context-independent optimisations

    - ### Methods inherited from class net.sf.saxon.pattern.Pattern

      `getColumnNumber, getContainerGranularity, getDefaultPriority, getExecutable, getHostLanguage, getLineNumber, getLocationProvider, getPublicId, getSystemId, make, replaceCurrent, selectNodes, setOriginalText, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### AncestorQualifiedPattern

          public AncestorQualifiedPattern(Pattern base,
                                  Pattern upper,
                                  byte axis)

  - ### Method Detail

    - #### setLineNumber

          public void setLineNumber(int lineNumber)

      Description copied from class: `Pattern`
      Set the line number where the pattern occurred
      Overrides:
        `setLineNumber` in class `Pattern`
      Parameters:
        `lineNumber` - the line number of the pattern in the source module

    - #### setSystemId

          public void setSystemId(String systemId)

      Description copied from class: `Pattern`
      Set the system ID where the pattern occurred
      Overrides:
        `setSystemId` in class `Pattern`
      Parameters:
        `systemId` - the URI of the module containing the pattern

    - #### setExecutable

          public void setExecutable(Executable executable)

      Set the executable containing this pattern
      Overrides:
        `setExecutable` in class `Pattern`
      Parameters:
        `executable` - the executable

    - #### bindCurrent

          public void bindCurrent(Binding binding)

      Replace any calls on current() by a variable reference bound to the supplied binding
      Overrides:
        `bindCurrent` in class `Pattern`

    - #### getBasePattern

          public Pattern getBasePattern()

      Get the base pattern, the pattern applying to the node itself
      Returns:
        the base pattern

    - #### getUpperPattern

          public Pattern getUpperPattern()

      Get the pattern applying to the parent node, if there is one
      Returns:
        the parent pattern, for example if the pattern is a/b[1]/c then the parent pattern is a/b[1]

    - #### getUpwardsAxis

          public byte getUpwardsAxis()

      Get the upwards axis, that is, the axis by which the upper pattern is reached. Typically Axis.PARENT or Axis.ANCESTOR

    - #### isMotionless

          public boolean isMotionless(boolean allowExtensions)

      Test whether a pattern is motionless, that is, whether it can be evaluated against a node without repositioning the input stream. This is a necessary condition for patterns used as the match pattern of a streamed template rule.
      Overrides:
        `isMotionless` in class `Pattern`
      Parameters:
        `allowExtensions` - if false, the result is determined strictly according to the W3C guaranteed streamability rules. If true, Saxon extensions are permitted: that is, constructs may be recognized as motionless by Saxon even if they are not recognized as motionless by the W3C rules.
      Returns:
        true if the pattern is motionless, that is, if it can be evaluated against a streamed node without changing the position in the streamed input file

    - #### simplify

          public Pattern simplify(ExpressionVisitor visitor)
                           throws XPathException

      Simplify the pattern: perform any context-independent optimisations
      Overrides:
        `simplify` in class `Pattern`
      Parameters:
        `visitor` - an expression visitor
      Returns:
        the optimised Pattern
      Throws:
        `XPathException`

    - #### analyze

          public Pattern analyze(ExpressionVisitor visitor,
                        ExpressionVisitor.ContextItemType contextItemType)
                          throws XPathException

      Type-check the pattern, performing any type-dependent optimizations.
      Overrides:
        `analyze` in class `Pattern`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the type of the context item at the point where the pattern appears
      Returns:
        the optimised Pattern
      Throws:
        `XPathException`

    - #### getDependencies

          public int getDependencies()

      Get the dependencies of the pattern. The only possible dependency for a pattern is on local variables. This is analyzed in those patterns where local variables may appear.
      Overrides:
        `getDependencies` in class `Pattern`
      Returns:
        the dependencies, as a bit-significant mask

    - #### iterateSubExpressions

          public Iterator<Expression> iterateSubExpressions()

      Iterate over the subexpressions within this pattern
      Overrides:
        `iterateSubExpressions` in class `Pattern`
      Returns:
        an iterator over the subexpressions. Default implementation returns an empty sequence

    - #### replaceSubExpression

          public boolean replaceSubExpression(Expression original,
                                     Expression replacement)

      Replace one subexpression by a replacement subexpression
      Overrides:
        `replaceSubExpression` in class `Pattern`
      Parameters:
        `original` - the original subexpression
        `replacement` - the replacement subexpression
      Returns:
        true if the original subexpression is found

    - #### allocateSlots

          public int allocateSlots(SlotManager slotManager,
                          int nextFree)

      Allocate slots to any variables used within the pattern
      Overrides:
        `allocateSlots` in class `Pattern`
      Parameters:
        `slotManager` -
        `nextFree` - the next slot that is free to be allocated @return the next slot that is free to be allocated
      Returns:
        the next slot that is free to be allocated

    - #### promote

          public void promote(PromotionOffer offer,
                     Expression parent)
                       throws XPathException

      Offer promotion for subexpressions within this pattern. The offer will be accepted if the subexpression is not dependent on the factors (e.g. the context item) identified in the PromotionOffer. By default the offer is not accepted - this is appropriate in the case of simple expressions such as constant values and variable references where promotion would give no performance advantage. This method is always called at compile time.

      Unlike the corresponding method on `Expression`, this method does not return anything: it can make internal changes to the pattern, but cannot return a different pattern. Only certain kinds of promotion are applicable within a pattern: specifically, promotions affecting local variable references within the pattern.

      Overrides:
        `promote` in class `Pattern`
      Parameters:
        `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
        `parent` -
      Throws:
        `XPathException` - if any error is detected

    - #### matches

          public boolean matches(Item item,
                        XPathContext context)
                          throws XPathException

      Determine whether the pattern matches a given item.
      Specified by:
        `matches` in class `Pattern`
      Parameters:
        `item` - the item to be tested
        `context` - The dynamic context. Only relevant if the pattern uses variables, or contains calls on functions such as document() or key().
      Returns:
        true if the pattern matches, else false
      Throws:
        `XPathException` - if an error occurs while matching the pattern (the caller will usually treat this the same as a false result)

    - #### matchesBeneathAnchor

          public boolean matchesBeneathAnchor(NodeInfo node,
                                     NodeInfo anchor,
                                     XPathContext context)
                                       throws XPathException

      Determine whether this pattern matches a given Node within the subtree rooted at a given anchor node. This method is used when the pattern is used for streaming.
      Overrides:
        `matchesBeneathAnchor` in class `Pattern`
      Parameters:
        `node` - The NodeInfo representing the Element or other node to be tested against the Pattern
        `anchor` - The anchor node, which must match any AnchorPattern subpattern
        `context` - The dynamic context. Only relevant if the pattern uses variables, or contains calls on functions such as document() or key().
      Returns:
        true if the node matches the Pattern, false otherwise
      Throws:
        `XPathException` - if an error occurs while matching the pattern (the caller will usually treat this the same as a false result)

    - #### getNodeKind

          public int getNodeKind()

      Determine the types of nodes to which this pattern applies. Used for optimisation. For patterns that match nodes of several types, return Node.NODE
      Overrides:
        `getNodeKind` in class `Pattern`
      Returns:
        the type of node matched by this pattern. e.g. Node.ELEMENT or Node.TEXT

    - #### getFingerprint

          public int getFingerprint()

      Determine the fingerprint of nodes to which this pattern applies. Used for optimisation.
      Overrides:
        `getFingerprint` in class `Pattern`
      Returns:
        the fingerprint of nodes matched by this pattern.

    - #### getItemType

          public ItemType getItemType()

      Get a NodeTest that all the nodes matching this pattern must satisfy
      Specified by:
        `getItemType` in class `Pattern`
      Returns:
        an ItemType, as specific as possible, which all the matching items satisfy

    - #### equals

          public boolean equals(Object other)

      Determine whether this pattern is the same as another pattern
      Overrides:
        `equals` in class `Object`
      Parameters:
        `other` - the other object

    - #### hashCode

          public int hashCode()

      hashcode supporting equals()
      Overrides:
        `hashCode` in class `Object`

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.